<?php
class ControllerShippingFlat extends Controller {
	private $error = array();

	public function index() {
		$language = $this->load->language('shipping/flat');
		$this->data = array_merge($this->data, $language);

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		$this->load->type('tipocomum');
		$this->load->helper('ftr_geral');

		$this->data['ftr_geral'] = new ftr_geral();
		
		$this->data['Type_Status'] = $this->load->typeForTwig('Type_Status');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (isset($this->request->post['flat_cost'])) {
				$this->request->post['flat_cost'] = ftr_geral::removeMaskToDouble($this->request->post['flat_cost']);
			}	
			if (isset($this->request->post['flat_total_minimo'])) {
				$this->request->post['flat_total_minimo'] = ftr_geral::removeMaskToDouble($this->request->post['flat_total_minimo']);
			}						
			$this->model_setting_setting->editSetting('flat', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL'));
		}

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_shipping'),
			'href'      => $this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL'),
      		'separator' => ' :: '
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('shipping/flat', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL'),
      		'separator' => ' :: '
   		);

		$this->data['action'] = $this->url->link('shipping/flat', 'token=' . $this->session->data['token'] . '&type=' . $this->request->get['type'], 'SSL');

		$this->data['cancel'] = $this->url->linkAnchor('extension/module', 'token=' . $this->session->data['token'], 'tab-info=' . $this->request->get['type'], 'SSL');

		if (isset($this->request->post['flat_cost'])) {
			$this->data['flat_cost'] = $this->request->post['flat_cost'];
		} else {
			$this->data['flat_cost'] = str_replace(',', '.', $this->config->get('flat_cost'));
		}

		if (isset($this->request->post['flat_total_minimo'])) {
			$this->data['flat_total_minimo'] = $this->request->post['flat_total_minimo'];
		} else if ($this->config->get('flat_total_minimo')){
			$this->data['flat_total_minimo'] = str_replace(',', '.', $this->config->get('flat_total_minimo'));
		} else {
			$this->data['flat_total_minimo'] = 0;
		}

		if (isset($this->request->post['flat_geo_zone_id'])) {
			$this->data['flat_geo_zone_id'] = $this->request->post['flat_geo_zone_id'];
		} else {
			$this->data['flat_geo_zone_id'] = $this->config->get('flat_geo_zone_id');
		}

		$this->load->model('localisation/geo_zone');

		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		if (isset($this->request->post['flat_status'])) {
			$this->data['flat_status'] = $this->request->post['flat_status'];
		} else {
			$this->data['flat_status'] = $this->config->get('flat_status');
		}

		if (isset($this->request->post['flat_sort_order'])) {
			$this->data['flat_sort_order'] = $this->request->post['flat_sort_order'];
		} else {
			$this->data['flat_sort_order'] = $this->config->get('flat_sort_order');
		}


		$this->children = array(
			'common/header',
			'common/footer'
		);
		$this->template = 'shipping/flat.twig';
		$this->response->setOutput($this->render());

	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/flat')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if(trim($this->request->post['flat_cost'])==''){
			$this->error['warning'] = $this->language->get('error_cost');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}
}
